<?php
/**
 * add_new_relation_view.php
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       http://nasirahmed.com
 * @since      1.0.0
 *
 * @package    Form_To_Sheet
 * @subpackage Form_To_Sheet/admin/partials
 */
?>


<div class="wrap">

    <div id="icon-options-general" class="icon32">  </div>
    <h1> <?php esc_attr_e( 'New Mapping', 'form-to-sheet' ); ?></h1>

    <div id="sheetToformRelation">

        <div id="post-body" class="metabox-holder ">

            <form action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>" method="post" >

                <input type="hidden" name="action" value="fts_save_submitted_relations">

                <input type="hidden" name="status" value="new_relation" />

                <h2><?php esc_attr_e( 'Select Form and Sheet', 'form-to-sheet' ); ?></h2>
                <table class="widefat">

                    <tbody>
                    <tr class="alternate">
                        <td class="row-title">
                            <label for="tablecell">
                                <?php esc_attr_e( 'Title', 'form-to-sheet' ); ?>
                            </label>
                        </td>
                        <td>
                            <input type="text" class="regular-text" v-model="title" name="relation_title" placeholder="<?php _e( 'Enter title here', 'form-to-sheet'); ?>" required="required">
                        </td>
                    </tr>
                    <tr>
                        <td class="row-title">
                            <label for="tablecell">
                                <?php esc_attr_e( 'Form Provider', 'form-to-sheet' ); ?>
                            </label>
                        </td>
                        <td>
                            <select name="formProviderId" v-model="formProviderId" @change="changedFormProvider">
                                <option value=""> <?php _e( 'Select...', 'form-to-sheet' ); ?> </option>
                                <?php
                                foreach ( $form_providers as $key => $value ) {
                                    echo "<option value='" . $key . "'> " . $value . " </option>";
                                } ?>
                            </select>
                        </td>
                    </tr>
                    <tr class="alternate">
                        <td class="row-title">
                            <label for="tablecell">
                                <?php esc_attr_e( 'Form Name', 'form-to-sheet' ); ?>
                            </label>
                        </td>
                        <td>
                            <select name="selectedFormId" v-model="selectedFormId" :disabled="formValidated == 1" @change="changedForm">
                                <option value=""> <?php _e( 'Select...', 'form-to-sheet' ); ?> </option>
                                <option v-for="(item, index) in forms" :value="index" > {{ item }}  </option>
                            </select>
                        </td>
                    </tr>
                    <tr>
                        <td class="row-title">
                            <label for="tablecell">
                                <?php esc_attr_e( 'Spreadsheet Provider', 'form-to-sheet' ); ?>
                            </label>
                        </td>
                        <td>
                            <select name="spreadsheetProviderId" v-model="spreadsheetProviderId" @change="changedSpreadsheetProvider">
                                <option value=""> <?php _e( 'Select...', 'form-to-sheet' ); ?> </option>
                                <?php
                                foreach ( $spreadsheet_providers as $key => $value ) {
                                echo "<option value='" . $key . "'> " . $value . " </option>";
                                }
                                ?>
                            </select>
                        </td>
                    </tr>

                    <?php do_action( 'fts_selected_spreadsheet_handler' ) ?>

                    </tbody>
                </table>
                <br>
                <!-- Sheet Fields  -->
                <div v-if="selectedWorksheet" >

                <h2><?php esc_attr_e( 'Form and Sheet Relations', 'form-to-sheet' ); ?></h2>

                <table class="widefat" >
                	<thead>
                    	<tr>
                    		<th class="row-title"><b><?php esc_attr_e( 'Worksheet Column Header', 'form-to-sheet' );?></b> </th>
                    		<th><b> <?php esc_attr_e( 'Form Field', 'form-to-sheet' ); ?></b> </th>
                    	</tr>
                	</thead>

                	<tbody>

                    <tr class="alternate" v-for="(item, index) in sheetColumnTitles" :value="index" >
                        <td>
                            <label for="tablecell">
                                <b> {{ index }} </b> - {{ item }}
                            </label>
                        </td>

                        <td>
                            <select  :name="'relations[' + index + ']'"  v-model="ColumTitlesTofieldRel[index]"   >
                                <option value=""><?php _e( 'Select...', 'form-to-sheet' ); ?></option>
                                <option v-for="(item, index) in formFields" :value="index" > {{ item }}  </option>
                            </select>
                        </td>
                    </tr>

                	</tbody>

                	<tfoot>
                	<tr>
                		<th class="row-title"><b><?php esc_attr_e('Worksheet Column Title', 'form-to-sheet' ); ?></b></th>
                        <th><b><?php esc_attr_e( 'Form Field', 'form-to-sheet' ); ?></b></th>
                	</tr>
                	</tfoot>

                </table>
                <!-- #postbox-container-1 .postbox-container -->
                </div>

                <br>
                <!-- Save intigartion Starts -->
                <div>
                    <p>
                       <input class="button-primary" type="submit" name="save_relation" value="<?php esc_attr_e( 'Save Relation', 'form-to-sheet' ); ?>" />

                       <a class="button-secondary" style="color: red" href="<?php echo admin_url('admin.php?page=form-to-sheet')?>" class="button-secondary"> <?php esc_attr_e( 'Cancel', 'form-to-sheet' ); ?></a>
                    </p>
                </div>
                <!-- Save intigartion Ends -->
            </form>

        </div>
        <!-- #post-body .metabox-holder .columns-2 -->

        <br class="clear">
    </div>
    <!-- #poststuff -->

</div> <!-- .wrap -->

