<?php
/**
 * add_new_relation_view.php
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       http://nasirahmed.com
 * @since      1.0.0
 *
 * @package    Form_To_Sheet
 * @subpackage Form_To_Sheet/admin/partials
 */
?>
<div class="wrap">

	<div id="icon-options-general" class="icon32"></div>
	<h1><?php esc_attr_e( "Form to Sheet Settings", "form-to-sheet" ); ?></h1>

	<?php
		$current_tab = isset( $_REQUEST['tab'] ) ? $_REQUEST['tab'] : 'gsheet';
	?>
	<h2 class="nav-tab-wrapper">
		<?php foreach ($tabs as $tab_key => $tab_label) { ?>
			<a class="nav-tab <?php echo ( $current_tab == $tab_key ) ? 'nav-tab-active' : ''; ?>" href="<?php echo admin_url( 'admin.php?page=form-to-sheet-settings&tab=' ) . $tab_key; ?>"><?php echo $tab_label ?></a>
		<?php } ?>
	</h2>

    <?php
        if( $current_tab == 'gsheet' ) {
            ?>
            <?php
            $nonce                  = wp_create_nonce( "fts_gcode" );
            $token_status           = get_option( 'fts_access_token_status' );
            $fts_google_access_code = get_option( "fts_google_access_code" ) ? get_option( "fts_google_access_code" ) : "";
            ?>

            <form name="Google_code_save_form" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>"
                  method="post" class="container">
                <?php
                if ( $token_status == 'false' ) { ?>
                    <h2><?php _e( 'Google Sheet Account', 'form-to-sheet' ) ?> <span
                            class='dashicons dashicons-dismiss not-activate'></span><span
                            class='fts-red-text'><?php _e( 'Not Connected', 'form-to-sheet' ) ?> </span></h2> </br>
                <?php }

                if ( $token_status == 'true' ) { ?>
                    <h2><?php _e( 'Google Sheet Account', 'form-to-sheet' ) ?> <span
                            class='dashicons dashicons-yes activate'></span><span
                            class='fts-green-text'><?php _e( 'Connected', 'form-to-sheet' ) ?> </span></h2> </br>
                <?php } ?>

                <input type="hidden" name="action" value="fts_save_gaccess_code">
                <input type="hidden" name="add_meta_nonce" value="<?php echo $nonce ?>"/>

                <table class="form-table">
                    <tr valign="top">
                        <th scope="row"> <?php _e( 'Google Access Code', 'form-to-sheet' ); ?></th>
                        <td>
                            <input type="text" name="fts_google_access_code"
                                   value="<?php echo $fts_google_access_code; ?>" placeholder="Please enter access code"
                                   class="regular-text"/>
                            <p class="description" id="code-description"><a
                                    href="https://accounts.google.com/o/oauth2/auth?response_type=code&access_type=offline&client_id=183316401948-n2kji5f6c55qfa3g9o8vh5t9mdfg373q.apps.googleusercontent.com&redirect_uri=urn%3Aietf%3Awg%3Aoauth%3A2.0%3Aoob&state&scope=https%3A%2F%2Fwww.googleapis.com%2Fauth%2Fdrive&approval_prompt=auto"
                                    target="_blank"><?php _e( 'Click here to get code', 'form-to-sheet' ); ?></a></p>
                        </td>
                    </tr>
                </table>
                <?php submit_button(); ?>
            </form>
            <?php
        }

    do_action( 'fts_settings_view', $current_tab );
    ?>
</div> <!-- .wrap -->


