<?php

/*
Plugin Name:       Forms to Sheets
Plugin URI:        http://nasirahmed.com/form-to-sheet
Description:       Data transfer plugin from various forms to various sheets.
Version:           2.1.1
Author:            Nasir Ahmed
Author URI:        http://nasirahmed.com
License:           GPL-2.0+
License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
Text Domain:       form-to-sheet
Domain Path:       /languages
*/

if ( !function_exists( 'form_to_sheet' ) ) {
    // Create a helper function for easy SDK access.
    function form_to_sheet()
    {
        global  $form_to_sheet ;

        if ( !isset( $form_to_sheet ) ) {
            // Include Freemius SDK.
            require_once dirname( __FILE__ ) . '/freemius/start.php';
            $form_to_sheet = fs_dynamic_init( array(
                'id'             => '3668',
                'slug'           => 'form-to-sheet',
                'type'           => 'plugin',
                'public_key'     => 'pk_d9b6a90a12e9b4162334dc7ed2005',
                'is_premium'     => false,
                'premium_suffix' => 'Personal',
                'has_addons'     => false,
                'has_paid_plans' => true,
                'menu'           => array(
                'slug'   => 'form-to-sheet-settings',
                'parent' => array(
                'slug' => 'form-to-sheet',
            ),
            ),
                'is_live'        => true,
            ) );
        }

        return $form_to_sheet;
    }

    // Init Freemius.
    form_to_sheet();
    // Signal that SDK was initiated.
    do_action( 'form_to_sheet_loaded' );
}

# If this file is called directly, abort.
if ( !defined( 'WPINC' ) ) {
    die;
}
/**
 * Currently plugin version.
 * Start at version 1.0.0 and use SemVer - https://semver.org
 * Rename this for your plugin and update it as you release new versions.
 */
define( 'FORM_TO_SHEET_VERSION', '2.1.1' );
/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-form-to-sheet-activator.php
 */
function form_to_sheet_activate()
{
    require_once plugin_dir_path( __FILE__ ) . 'includes/class-form-to-sheet-activator.php';
    Form_To_Sheet_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-form-to-sheet-deactivator.php
 */
function form_to_sheet_deactivate()
{
    require_once plugin_dir_path( __FILE__ ) . 'includes/class-form-to-sheet-deactivator.php';
    Form_To_Sheet_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'form_to_sheet_activate' );
register_deactivation_hook( __FILE__, 'form_to_sheet_deactivate' );
/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-form-to-sheet.php';
if ( form_to_sheet()->is__premium_only() ) {
   if ( form_to_sheet()->is_plan( 'personal', true ) ) {
require plugin_dir_path( __FILE__ ) . 'platforms/gravityforms/form-to-sheet-gravityforms.php';
require plugin_dir_path( __FILE__ ) . 'platforms/weforms/form-to-sheet-weforms.php';
require plugin_dir_path( __FILE__ ) . 'platforms/calderaforms/form-to-sheet-calderaforms.php';
require plugin_dir_path( __FILE__ ) . 'platforms/ninjaforms/form-to-sheet-ninjaforms.php';
require plugin_dir_path( __FILE__ ) . 'platforms/wpforms/form-to-sheet-wpforms.php';
require plugin_dir_path( __FILE__ ) . 'platforms/formidable/form-to-sheet-formidable.php';
require plugin_dir_path( __FILE__ ) . 'platforms/smartforms/form-to-sheet-smartforms.php';
require plugin_dir_path( __FILE__ ) . 'platforms/everestforms/form-to-sheet-everestforms.php';
require plugin_dir_path( __FILE__ ) . 'platforms/formcraft/form-to-sheet-formcraft.php';
require plugin_dir_path( __FILE__ ) . 'platforms/happyforms/form-to-sheet-happyforms.php';
require plugin_dir_path( __FILE__ ) . 'platforms/forminator/form-to-sheet-forminator.php';
require plugin_dir_path( __FILE__ ) . 'platforms/plansoforms/form-to-sheet-plansoforms.php';
require plugin_dir_path( __FILE__ ) . 'platforms/smartsheet/form-to-sheet-smartsheet.php';
   }
}
function ftos_get_form_providers()
{
    include_once ABSPATH . 'wp-admin/includes/plugin.php';
    $providers = array();
    if ( is_plugin_active( 'contact-form-7/wp-contact-form-7.php' ) ) {
        $providers['cf7'] = __( 'Contact Form 7', 'form-to-sheet' );
    }
    return apply_filters( 'fts_form_providers', $providers );
}

function ftos_get_spreadsheet_providers()
{
    $providers = array();
    $token_status = get_option( 'fts_access_token_status' );
    if ( $token_status == 'true' ) {
        $providers['gsheet'] = __( 'Google Sheets', 'form-to-sheet' );
    }
    return apply_filters( 'fts_spreadsheet_providers', $providers );
}

# Redirect
function form_to_sheet_redirect( $url )
{
    $string = '<script type="text/javascript">';
    $string .= 'window.location = "' . $url . '"';
    $string .= '</script>';
    echo  $string ;
}

function ftos_get_user_ip()
{
    // Get real visitor IP behind CloudFlare network

    if ( isset( $_SERVER["HTTP_CF_CONNECTING_IP"] ) ) {
        $_SERVER['REMOTE_ADDR'] = $_SERVER["HTTP_CF_CONNECTING_IP"];
        $_SERVER['HTTP_CLIENT_IP'] = $_SERVER["HTTP_CF_CONNECTING_IP"];
    }

    $client = @$_SERVER['HTTP_CLIENT_IP'];
    $forward = @$_SERVER['HTTP_X_FORWARDED_FOR'];
    $remote = $_SERVER['REMOTE_ADDR'];

    if ( filter_var( $client, FILTER_VALIDATE_IP ) ) {
        $ip = $client;
    } elseif ( filter_var( $forward, FILTER_VALIDATE_IP ) ) {
        $ip = $forward;
    } else {
        $ip = $remote;
    }

    return $ip;
}

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function form_to_sheet_run()
{
    $plugin = new Form_To_Sheet();
    $plugin->run();
}

form_to_sheet_run();