<?php
/**
 * Fired during plugin activation
 *
 * @link       http://nasirahmed.com
 * @since      1.0.0
 *
 * @package    Form_To_Sheet
 * @subpackage Form_To_Sheet/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Form_To_Sheet
 * @subpackage Form_To_Sheet/includes
 * @author     Nasir Ahmed <nasir9bd@gmail.com>
 */
class Form_To_Sheet_Activator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	*/


	public static function activate() {
		global $wpdb;
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

		$collate = '';

		if ( $wpdb->has_cap( 'collation' ) ) {
		    if ( ! empty($wpdb->charset ) ) {
		        $collate .= "DEFAULT CHARACTER SET $wpdb->charset";
		    }

		    if ( ! empty($wpdb->collate ) ) {
		        $collate .= " COLLATE $wpdb->collate";
		    }
		}

		$SQL = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}form_to_sheet(
		      `id` bigint(20) NOT NULL AUTO_INCREMENT,
		      `integration_title` varchar(250) NOT NULL,
		      `form_provider` varchar(250) NOT NULL,
		      `form_id` varchar(250) NOT NULL,
		      `form_name` varchar(250) NOT NULL,
		      `spreadsheet_provider` varchar(250) NOT NULL,
		      `spreadsheet_id` varchar(250) NOT NULL,
		      `spreadsheet_name` varchar(250) NOT NULL,
		      `worksheet` varchar(250) NOT NULL,
		      `relations` text NOT NULL,
		      `status` varchar(25) NOT NULL,
		      `time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
		       KEY `id` (`id`)
		    ) $collate;";
		dbDelta( $SQL );
	}

}