<?php
/**
 * Define the internationalization functionality
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @link       http://nasirahmed.com
 * @since      1.0.0
 *
 * @package    Form_To_Sheet
 * @subpackage Form_To_Sheet/includes
 */

/**
 * Define the internationalization functionality.
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @since      1.0.0
 * @package    Form_To_Sheet
 * @subpackage Form_To_Sheet/includes
 * @author     Nasir Ahmed <nasir9bd@gmail.com>
 */
class Form_To_Sheet_i18n {


	/**
	 * Load the plugin text domain for translation.
	 *
	 * @since    1.0.0
	 */
	public function load_plugin_textdomain() {

		load_plugin_textdomain(
			'form-to-sheet',
			false,
			dirname( dirname( plugin_basename( __FILE__ ) ) ) . '/languages/'
		);

	}



}
