<?php

add_action( 'wpcf7_mail_sent', 'ftos_cf7_connection' );

function ftos_cf7_connection( $WPCF7_ContactForm ) {

    $submission  = WPCF7_Submission::get_instance();
    $posted_data = $submission->get_posted_data();
    $form_id     = $posted_data['_wpcf7'];

    $posted_data["submission_date"] = date( "Y-m-d" );
    $posted_data["user_ip"] = ftos_get_user_ip();

    global $wpdb;

    $saved_records = $wpdb->get_results( "SELECT * FROM {$wpdb->prefix}form_to_sheet WHERE status = 1 AND form_provider = 'cf7' AND form_id = ".$form_id , ARRAY_A );

    foreach ( $saved_records as $record ) {
        $spreadsheet_provider = $record['spreadsheet_provider'];
        call_user_func( "ftos_{$spreadsheet_provider}_send_data", $record, $posted_data );
    }

    return $WPCF7_ContactForm;
}

function ftos_cf7_get_forms( $form_provider ) {
    if( $form_provider != 'cf7' ) {
        return;
    }

    $args     = array( 'post_type' => 'wpcf7_contact_form', 'posts_per_page' => -1 );
    $cf7Forms = get_posts( $args );
    $forms    = wp_list_pluck( $cf7Forms, 'post_title', 'ID' );

    return $forms;
}

function ftos_cf7_get_form_fields( $form_provider, $form_id ) {
    if( $form_provider != 'cf7' ) {
        return;
    }

    $meta   = get_post_meta( $form_id, '_form', true );
    $fields = fts_cf7_form_field_parser( $meta );
    $final_fields = array();

    if( $fields ) {
        foreach ( $fields as $field ) {
            $single = fts_cf7_field_type_and_key_pair( $field );
            if ( $single ) {
                $final_fields[$single] = $single;
            }
        }
    }

//    $final_fields["submission_date"] = __( "Submission Date", "form-to-sheet" );
    return $final_fields;
}

function fts_cf7_form_field_parser( $val ) {
    $array = [];

    if ( preg_match_all('/\[.*\]/', $val, $array) == false ) {
        return false;
    }

    return $array[0];
}

function fts_cf7_field_type_and_key_pair( $content ) {
    $regexp_type = '/(?<=\[)[^\s\*]*/';
    $regexp_name = '/(?<=\s)[^\s\]]*/';
    $Field_type  = [];
    $Field_key   = [];

    if ( preg_match( $regexp_type, $content, $Field_type ) == false ) {
        return false;
    }

    if ( !in_array($Field_type[0], ['text', 'email', 'url', 'tel', 'number', 'range', 'date', 'textarea', 'select', 'checkbox', 'radio', 'acceptance', 'quiz', 'file', 'hidden' ] ) ) {
        return false;
    }

    if ( preg_match($regexp_name, $content, $Field_key ) == false ) {
        return false;
    }

    return $Field_key[0];
}

function ftos_cf7_get_form_name( $form_provider, $form_id ) {
    if( $form_provider != 'cf7' ) {
        return;
    }

    $form = get_post( $form_id );

    return $form->post_title;
}
