<?php

class Form_To_Sheet_GSheet2 {
    private $token;
    private $spreadsheet;
    private $worksheet;

    const clientId     = '183316401948-n2kji5f6c55qfa3g9o8vh5t9mdfg373q.apps.googleusercontent.com';
    const clientSecret = 'CFHFu3kL592Gfci84v4O47PU';
    const redirect     = 'urn:ietf:wg:oauth:2.0:oob';

    public function __construct() {
        self::access_token_validation_check();
        $this->actions();
    }

    public function actions() {
        add_action( 'fts_selected_spreadsheet_handler', array( $this, 'fts_gsheet_selected_spreadsheet_handler' ) );
        add_action( 'fts_selected_spreadsheet_handler_edit', array( $this, 'fts_gsheet_selected_spreadsheet_handler_edit' ) );
        add_action( 'admin_post_fts_save_gaccess_code', array( $this, 'fts_save_gaccess_code' ) );
        add_action( 'fts_spreadsheets_list', array( $this, 'fts_gsheet_spreadsheets_list' ) );
        add_action( 'fts_worksheets_list', array( $this, 'fts_gsheet_worksheets_list' ) );
        add_action( 'fts_sheet_columns', array( $this, 'fts_gsheet_sheet_columns' ) );
        add_action( 'fts_save_relations', array( $this, 'fts_gsheet_save_relations' ) );
    }

    public function fts_gsheet_worksheets_list( $spreadsheet_provider ) {

        if( $spreadsheet_provider != 'gsheet' ) {
            return;
        }

        $spreadsheet_id = $_POST['spreadsheetId'];
        $sheets         = fts_gsheet_get_worksheets_list( $spreadsheet_provider, $spreadsheet_id );


        if ( empty( $sheets ) ) {
            return false ;
        } else {
            return wp_send_json_success( $sheets );
        }
    }

    public function fts_gsheet_save_relations() {

        $spreadsheet_provider_id = sanitize_text_field( $_POST['spreadsheetProviderId'] );

        if( $spreadsheet_provider_id != 'gsheet' ) {
            return;
        }

        $form_provider_id = sanitize_text_field( $_POST['formProviderId'] );
        $form_id          = sanitize_text_field( $_POST['selectedFormId'] );
        $spreadsheet_id   = sanitize_text_field( $_POST['spreadsheet_id'] );
        $worksheet        = sanitize_text_field( $_POST['worksheet'] );

        if ( empty( $form_provider_id ) || empty( $form_id ) || empty( $spreadsheet_provider_id ) || empty( $spreadsheet_id ) || empty( $worksheet ) ) {
            form_to_sheet_redirect( admin_url( 'admin.php?page=form-to-sheet&action=new' ) );
            die();
        }

        $fts_access_token         = json_decode( get_option( 'fts_access_token' ), true );
        $worksheets_column_titles = $this->get_sheet_details( $spreadsheet_id, $worksheet, $fts_access_token['access_token'] );
        $relation_full_array      = array();

        foreach ( $worksheets_column_titles as $key => $value ) {

            if ( isset( $_POST['relations'][ $key ] ) ) {
                $relation_full_array[$key] = $_POST['relations'][ $key ];
            } else {
                $relation_full_array[$key] = null;
            }
        }

        $title  = sanitize_text_field( $_POST['relation_title'] );
        $status = sanitize_text_field( $_POST['status'] );

        global $wpdb;

        $relation_table   = $wpdb->prefix . 'form_to_sheet';

        if ( $status == 'new_relation' ) {

            $action_status = $wpdb->insert(
                $relation_table,
                array(
                    'integration_title'    => $title,
                    'form_provider'        => $form_provider_id,
                    'form_id'              => $form_id,
                    'form_name'            => call_user_func( "ftos_{$form_provider_id}_get_form_name", $form_provider_id, $form_id ),
                    'spreadsheet_provider' => $spreadsheet_provider_id,
                    'spreadsheet_id'       => $spreadsheet_id,
                    'spreadsheet_name'     => $this->google_spreadsheet_name_by_id( $spreadsheet_id ),
                    'worksheet'            => $worksheet,
                    'relations'            => json_encode( $relation_full_array, true ),
                    'status'               => true
                )
            );

        }

        if ( $status == 'update_relation' ) {

            $id = esc_sql( trim( $_POST['edit_id'] ) );

            if ( $status != 'update_relation' &&  !empty( $id ) ) {
                exit;
            }

            $action_status = $wpdb->update( $relation_table,
                array(
                    'integration_title'    => $title,
                    'form_provider'        => $form_provider_id,
                    'form_id'              => $form_id ,
                    'form_name'            => call_user_func( "ftos_{$form_provider_id}_get_form_name", $form_provider_id, $form_id ),
                    'spreadsheet_provider' => $spreadsheet_provider_id,
                    'spreadsheet_id'       => $spreadsheet_id ,
                    'spreadsheet_name'     => $this->google_spreadsheet_name_by_id($spreadsheet_id),
                    'worksheet'            => $worksheet ,
                    'relations'            =>  json_encode( $relation_full_array, true ),
                ),
                array(
                    'id'                => $id
                )
            );
        }

        if ( $action_status ) {
            form_to_sheet_redirect( admin_url( 'admin.php?page=form-to-sheet&status=1' ) );
        } else {
            form_to_sheet_redirect( admin_url( 'admin.php?page=form-to-sheet&status=0' ) );
        }
    }

    public function google_spreadsheet_name_by_id( $sheet_id = '' ) {

        if ( empty( $sheet_id ) ) {
            return false;
        }

        $g_access_token = json_decode( get_option( 'fts_access_token' ), true );
        $google_return  = wp_remote_get( 'https://sheets.googleapis.com/v4/spreadsheets/' . $sheet_id . '/?access_token=' . $g_access_token['access_token'] );
        $body           = json_decode( $google_return['body'], true );

        if ( empty($body['properties']['title'] ) ) {
            return false ;
        } else {
            return $body['properties']['title'];
        }
    }

    public function fts_gsheet_sheet_columns() {
        $spreadsheet_provider_id  = $_POST['spreadsheetProviderId'];

        if( $spreadsheet_provider_id != 'gsheet' ) {
            return;
        }

        $spreadsheet              = $_POST['spreadsheetId'];
        $worksheet                = $_POST['workSheetName'];
        $fts_access_token         = json_decode( get_option( 'fts_access_token' ), true );
        $worksheets_column_titles = $this->get_sheet_details( $spreadsheet, $worksheet, $fts_access_token['access_token']) ;
        wp_send_json_success( $worksheets_column_titles );
//        echo json_encode( $worksheets_column_titles );

        exit();
    }

    public function get_sheet_details( $spreadsheets_id='', $worksheet_name='', $token='' ) {

        $key_title_array = fts_gsheet_get_sheet_details( $spreadsheets_id, $worksheet_name, $token );

        return $key_title_array;
    }

    public function fts_gsheet_selected_spreadsheet_handler() {
        ?>
        <tr class="alternate" v-if="spreadsheetProviderId == 'gsheet'">
            <td class="row-title">
                <label for="tablecell">
                    <?php esc_attr_e( 'Spreadsheet Name', 'form-to-sheet' ); ?>
                </label>
            </td>
            <td>
                <select name="spreadsheet_id" v-model="spreadsheetId"  @change="changeSpreadsheet" :disabled="spreadsheetValidated == 1">
                    <option value=""> <?php _e( 'Select...', 'form-to-sheet' ); ?> </option>
                    <option v-for="(item, index) in spreadsheets" :value="index" > {{ item }}  </option>
                </select>
            </td>
        </tr>

        <tr v-if="spreadsheetProviderId == 'gsheet' && spreadsheetId">
            <td class="row-title">
                <label for="tablecell">
                    <?php esc_attr_e('Worksheet Name', 'form-to-sheet'); ?>
                </label>
            </td>

            <td>
                <select name="worksheet" v-model="selectedWorksheet" @change="changeWorksheet" :disabled="worksheetValidated == 1">
                    <option value=""><?php _e( 'Select...', 'form-to-sheet' ); ?> </option>
                    <option v-for="(item, index) in worksheets" :value="item" > {{ item }}  </option>
                </select>
            </td>
        </tr>
        <?php
    }

    public function fts_gsheet_selected_spreadsheet_handler_edit( $id ) {
        global $wpdb;

        $table                    = $wpdb->prefix . 'form_to_sheet';
        $data                     = $wpdb->get_row( "SELECT * FROM " . $table . " WHERE id =" . $id, ARRAY_A );
        $spreadsheet_provider     = $data["spreadsheet_provider"];
        if( $spreadsheet_provider != 'gsheet' ) {
            return;
        }
        $form_providers           = ftos_get_form_providers();
        $form_provider            = $data["form_provider"];
        $forms                    = call_user_func( "ftos_{$form_provider}_get_forms", $form_provider );
        $form_id                  = $data["form_id"];
        $form_fields              = call_user_func( "ftos_{$form_provider}_get_form_fields", $form_provider, $form_id );
        $spreadsheet_providers    = ftos_get_spreadsheet_providers();
        $spreadsheet_id           = $data["spreadsheet_id"];
        $spreadsheets_list        = fts_gsheet_get_spreadsheets_list( $spreadsheet_provider );
        $worksheets_list          = fts_gsheet_get_worksheets_list( $spreadsheet_provider, $spreadsheet_id );
        $worksheet                = $data["worksheet"];
        $worksheet_column_titles  = fts_gsheet_get_sheet_details( $spreadsheet_id, $worksheet );
        ?>
        <script type="text/javascript">
            var form_providers           = <?php echo json_encode( $form_providers ); ?>;
            var formProviderId           = <?php echo json_encode( $form_provider ); ?>;
            var forms                    = <?php echo json_encode( $forms ); ?>;
            var selectedFormId           = <?php echo json_encode( $form_id ); ?>;
            var formFields               = <?php echo json_encode( $form_fields ); ?>;
            var spreadsheet_providers    = <?php echo json_encode( $spreadsheet_providers ); ?>;
            var spreadsheetProviderId    = <?php echo json_encode( $spreadsheet_provider ); ?>;
            var saved_spadesheet_id      = <?php echo json_encode( $spreadsheet_id ); ?>;
            var worksheets               = <?php echo json_encode( $worksheets_list ); ?>;
            var saved_worksheet_name     = <?php echo json_encode( $worksheet ); ?>;
            var worksheets_column_titles = <?php echo json_encode( $worksheet_column_titles ); ?>;
            var saved_relations          = <?php echo json_encode( $data['relations'] ); ?>;
            var connection_title         = <?php echo json_encode( $data['integration_title'], true ); ?>;
            var spreadsheets             = <?php echo json_encode( $spreadsheets_list ); ?>;

            //    var saved_form_name          = <?php //echo json_encode( $data['form_name'], true ); ?>//;
        </script>
        <table class="widefat">
        <tbody>
        <tr class="alternate">
            <td class="row-title">
                <label for="tablecell">
                    <?php esc_attr_e( 'Title', 'form-to-sheet' ); ?>
                </label>
            </td>
            <td>
                <input type="text" class="regular-text" v-model="title" name="relation_title" placeholder="<?php _e( 'Enter title here', 'form-to-sheet'); ?>" required="required">
            </td>
        </tr>
        <tr>
            <td class="row-title">
                <label for="tablecell">
                    <?php esc_attr_e( 'Form Provider', 'form-to-sheet' ); ?>
                </label>
            </td>
            <td>
                <select name="formProviderId" v-model="formProviderId" disabled="disabled">
                    <option value=""> <?php _e( 'Select...', 'form-to-sheet' ); ?> </option>
                    <?php
                    foreach ( $form_providers as $key => $value ) {
                        echo "<option value='" . $key . "'> " . $value . " </option>";
                    } ?>
                </select>
            </td>
        </tr>
        <tr class="alternate">
            <td class="row-title">
                <label for="tablecell">
                    <?php esc_attr_e( 'Form Name', 'form-to-sheet' ); ?>
                </label>
            </td>
            <td>
                <select name="selectedFormId" v-model="selectedFormId" disabled>
                    <option value=""> <?php _e( 'Select...', 'form-to-sheet' ); ?> </option>
                    <option v-for="(item, index) in forms" :value="index" > {{ item }}  </option>
                </select>
            </td>
        </tr>
        <tr>
            <td class="row-title">
                <label for="tablecell">
                    <?php esc_attr_e( 'Spreadsheet Provider', 'form-to-sheet' ); ?>
                </label>
            </td>
            <td>
                <select name="spreadsheetProviderId" v-model="spreadsheetProviderId" disabled>
                    <option value=""> <?php _e( 'Select...', 'form-to-sheet' ); ?> </option>
                    <?php
                    foreach ( $spreadsheet_providers as $key => $value ) {
                        echo "<option value='" . $key . "'> " . $value . " </option>";
                    }
                    ?>
                </select>
            </td>
        </tr>
        <tr class="alternate" v-if="spreadsheetProviderId == 'gsheet'">
            <td class="row-title">
                <label for="tablecell">
                    <?php esc_attr_e( 'Spreadsheet Name', 'form-to-sheet' ); ?>
                </label>
            </td>
            <td>
                <select name="spreadsheet_id" v-model="spreadsheetId" disabled>
                    <option value=""> <?php _e( 'Select...', 'form-to-sheet' ); ?> </option>
                    <option v-for="(item, index) in spreadsheets" :value="index" > {{ item }}  </option>
                </select>
            </td>
        </tr>
        <tr v-if="spreadsheetProviderId == 'gsheet' && spreadsheetId">
            <td class="row-title">
                <label for="tablecell">
                    <?php esc_attr_e('Worksheet Name', 'form-to-sheet'); ?>
                </label>
            </td>

            <td>
                <select name="worksheet" v-model="selectedWorksheet" disabled>
                    <option value=""><?php _e( 'Select...', 'form-to-sheet' ); ?> </option>
                    <option v-for="(item, index) in worksheets" :value="item" > {{ item }}  </option>
                </select>
            </td>
        </tr>
        </tbody>
        </table>
        <br>
        <!-- Sheet Fields  -->
        <div v-if="selectedWorksheet" >

            <h2><?php esc_attr_e( 'Form and Sheet Relations', 'form-to-sheet' ); ?></h2>

            <table class="widefat" >
                <thead>
                <tr>
                    <th class="row-title"><b><?php esc_attr_e( 'Worksheet Column Header', 'form-to-sheet' );?></b> </th>
                    <th><b> <?php esc_attr_e( 'Form Field', 'form-to-sheet' ); ?></b> </th>
                </tr>
                </thead>

                <tbody>

                <tr class="alternate" v-for="(item, index) in sheetColumnTitles" :value="index" >
                    <td>
                        <label for="tablecell">
                            <b> {{ index }} </b> - {{ item }}
                        </label>
                    </td>

                    <td>
                        <select  :name="'relations[' + index + ']'" v-model="ColumTitlesTofieldRel[index]">
                            <option value=""><?php _e( 'Select...', 'form-to-sheet' ); ?></option>
                            <option v-for="(item,index) in formFields" :value="index" > {{ item }}  </option>
                        </select>
                    </td>
                </tr>

                </tbody>

                <tfoot>
                <tr>
                    <th class="row-title"><b><?php esc_attr_e('Worksheet Column Title', 'form-to-sheet' ); ?></b></th>
                    <th><b><?php esc_attr_e( 'Form Field', 'form-to-sheet' ); ?></b></th>
                </tr>
                </tfoot>

            </table>
        </div>
        <?php
    }

    public function fts_gsheet_spreadsheets_list( $spreadsheet_provider ) {

        if( $spreadsheet_provider != 'gsheet' ) {
            return;
        }

        $spreadsheets_id_and_title = fts_gsheet_get_spreadsheets_list( $spreadsheet_provider );

        wp_send_json_success( $spreadsheets_id_and_title );
    }

    public static function access_token_validation_check( $token = '' ){

        $token   = json_decode(get_option('fts_access_token'), true );
        $returns = self::access_token_expiration_checker( $token );

        if ( $returns['response_code'] != 200 ) {
            $new_token = self::get_access_token_by_refresh_token(self::clientId ,self::clientSecret,$token);

            if ($new_token['response_code'] == 200 ) {
                update_option('fts_access_token', json_encode($new_token, true));
                update_option('fts_access_token_status', 'true');
            } else {
                update_option('fts_access_token_status', 'false');
            }

        } else {
            update_option('fts_access_token_status', 'true');
        }

        if (get_option('fts_access_token_status') == true) {
            return true;
        }else{
            return false;
        }
    }

    public static function access_token_expiration_checker( $token ='' ) {
        $response = array();

        if ( empty($token ) || empty( $token['access_token'] ) ) {
            update_option( "fts_access_token_status", 'false');

            return;
        }

        $google_return = wp_remote_get('https://www.googleapis.com/oauth2/v1/tokeninfo?access_token='.$token['access_token']);

        if( is_wp_error( $google_return ) ) {
            return;
        }

        $google_body   =  json_decode($google_return['body'], true);

        if ( $google_return['response']['code'] == 200 ) {
            $response['issued_to']        = $google_body['issued_to'];
            $response['audience']         = $google_body['audience'];
            $response['scope']            = $google_body['scope'];
            $response['expires_in']       = $google_body['expires_in'];
            $response['access_type']      = $google_body['access_type'];
            $response['response_code']    = $google_return['response']['code'];
            $response['response_message'] = $google_return['response']['message'];
        } else {
            # error
            update_option( "fts_access_token_status", 'false');

            $response['issued_to']        = '';
            $response['audience']         = '';
            $response['scope']            = '';
            $response['expires_in']       = '';
            $response['access_type']      = '';
            $response['response_code']    = $google_return['response']['code'];
            $response['response_message'] = $google_return['response']['message'];
        }
        return 	$response ;
    }

    public static function get_access_token_by_refresh_token( $client_id ='', $client_secret ='' , $token ='' ){
        $response = array();

        if ( empty( $client_id ) || empty($client_secret ) ) {
            update_option( "fts_access_token_status", 'false');

            return;
        }

        if ( empty($token) || empty($token['refresh_token'] ) ) {
            update_option( "fts_access_token_status", 'false');

            return;
        }

        $url ='https://www.googleapis.com/oauth2/v4/token';

        $args = Array(
            'headers' => Array(),
            'body'    => array(
                'refresh_token' => $token['refresh_token'],
                'client_id'     => $client_id,
                'client_secret' => $client_secret,
                'grant_type'    => 'refresh_token',
            )
        );

        $google_return   = wp_remote_post($url, $args );

        if( is_wp_error( $google_return ) ) {
            return;
        }

        $google_body     = json_decode($google_return['body'], true);

        if ( $google_return['response']['code'] == 200 ) {
            $response['access_token']     = $google_body['access_token'];
            $response['expires_in']       = $google_body['expires_in'];
            $response['refresh_token']    = $token['refresh_token'];
            $response['scope']            = $google_body['scope'];
            $response['token_type']       = $google_body['token_type'];
            $response['created']          = time();
            $response['expire']           = time() + $google_body['expires_in'] ;
            $response['response_code']    = $google_return['response']['code'];
            $response['response_message'] = $google_return['response']['message'];
        } else {
            # error
            update_option( "fts_access_token_status", 'false');

            $response['access_token']     = '';
            $response['expires_in']       = '';
            $response['refresh_token']    = $token['refresh_token'];
            $response['scope']            = '';
            $response['token_type']       = '';
            $response['created']          = time();
            $response['expire']           = '';
            $response['response_code']    = $google_return['response']['code']   ;
            $response['response_message'] = $google_return['response']['message'];
        }

        return $response ;
    }

    public function fts_save_gaccess_code() {
        // Security Check
        if (! wp_verify_nonce( $_POST['add_meta_nonce'], 'fts_gcode' ) ) {
            die( __( 'Security check Failed', 'form-to-sheet' ) );
        }

        if ( empty( $_POST['fts_google_access_code'] ) ) {
            update_option( "fts_google_access_code", $_POST['fts_google_access_code'] );
            form_to_sheet_redirect( 'admin.php?page=form-to-sheet-settings&tab=gsheet' );
            exit;
        }

        $fts_google_access_code = get_option( 'fts_google_access_code' );

        if( $_POST['fts_google_access_code'] == $fts_google_access_code ) {
            form_to_sheet_redirect( admin_url( 'admin.php?page=form-to-sheet-settings&tab=gsheet' ) );
            exit;
        }

        $fts_access_token = $this->save_accessToken( $_POST["fts_google_access_code"] );
        // Save tokens
        update_option( "fts_google_access_code", $_POST["fts_google_access_code"] );
        update_option( "fts_access_token", json_encode( $fts_access_token, true ) );
        // User Confirmation
        if ( array_key_exists( "access_token", $fts_access_token ) ) {
            update_option( "fts_access_token_status", "true" );
            form_to_sheet_redirect( "admin.php?page=form-to-sheet-settings&status=1" );
        } else {
            form_to_sheet_redirect( "admin.php?page=form-to-sheet-settings" );
        }
    }

    public function save_accessToken( $access_code ){

        $accessToken = self::get_token_by_google_authorization_code(self::clientId , self::clientSecret , trim( $access_code ) );

        return $accessToken;
    }

    public static function get_token_by_google_authorization_code( $client_id = '', $client_secret = '', $google_access_code = '' ) {
        $response = array();

        if ( empty( $client_id ) || empty( $client_secret ) ) {
            update_option( "fts_access_token_status", 'false');
            form_to_sheet_redirect( admin_url( 'admin.php?page=form-to-sheet-settings' ) );
            exit;
        }

        if ( empty( $google_access_code ) ) {
            update_option( "fts_access_token_status", 'false');
            form_to_sheet_redirect( admin_url( 'admin.php?page=form-to-sheet-settings' ) );
            exit;
        }

        $url ='https://accounts.google.com/o/oauth2/token';

        $args = Array(
            'headers' => Array(),
            'body'    => array(
                'code'          => $google_access_code,
                'client_id'     => $client_id,
                'client_secret' => $client_secret,
                'redirect_uri'  => 'urn:ietf:wg:oauth:2.0:oob',
                'grant_type'    => 'authorization_code',
                'access_type'   => 'offline',
            )
        );

        $google_return = wp_remote_post( $url, $args );
        $google_body   = json_decode( $google_return['body'], true );


        if ( $google_return['response']['code'] == 200 ) {

            $response['access_token']     = $google_body['access_token'];
            $response['expires_in']       = $google_body['expires_in'];
            $response['refresh_token']    = $google_body['refresh_token'];
            $response['scope']            = $google_body['scope'];
            $response['token_type']       = $google_body['token_type'];
            $response['created']          = time();
            $response['expire']           = time() + $google_body['expires_in'];
            $response['response_code']    = $google_return['response']['code'];
            $response['response_message'] = $google_return['response']['message'];
        } else {
            # error
            $response['access_token']     = '';
            $response['expires_in']       = '';
            $response['refresh_token']    = '';
            $response['scope']            = '';
            $response['token_type']       = '';
            $response['created']          = time();
            $response['expire']           = '';
            $response['response_code']    = $google_return['response']['code'];
            $response['response_message'] = $google_return['response']['message'];
        }

        return $response ;
    }
}

function ftos_gsheet_send_data( $record, $posted_data ) {
    $spreadsheet_provider = $record['spreadsheet_provider'];

    if($spreadsheet_provider != 'gsheet' ) {
        return;
    }

    $spreadsheet_id    = $record['spreadsheet_id'];
    $worksheet_name    = $record['worksheet'];
    $database_relation = json_decode( $record['relations'], true );
    $accessToken       = json_decode( get_option( 'fts_access_token' ), true );
    $holder            = array();

    foreach ( $database_relation as $key => $value ) {
        $holder[$key] = isset( $posted_data[$value] ) ? $posted_data[$value] : "";
    }

    if ( !empty( $holder ) ) {
        $ret = ftos_gsheet_append_new_row( $accessToken['access_token'], $spreadsheet_id, $worksheet_name, $holder );
    }
}

function ftos_gsheet_append_new_row( $access_token = '', $spreadsheet_id = '', $worksheet_name = '', $data_array = '' ) {

    if ( empty( $access_token ) || empty( $spreadsheet_id ) ) {
        return "access_token or spreadsheet_id is empty";
    }

    if ( empty( $worksheet_name ) || empty( $data_array ) ) {
        return "worksheet_name or data_array is empty";
    }

    $final = array();

    foreach( $data_array as $key => $val ) {
        if( $val ) {
            $final[] = $val ;
        } else {
            $final[] ="" ;
        }
    }

    end( $data_array );

    $last_key = key($data_array);
    $url      = 'https://sheets.googleapis.com/v4/spreadsheets/' . $spreadsheet_id . '/values/' . $worksheet_name . '!A:' . $last_key . ':append?valueInputOption=USER_ENTERED';

    $args = array(

        'headers' => array(
            'Authorization'=>'Bearer ' . $access_token,
            'Content-Type' => 'application/json'
        ),
        'body' => '{"range":"' . $worksheet_name . '!A:' . $last_key . '","majorDimension":"ROWS","values":[' . json_encode( $final ) .']}'
    );

    $google_return = wp_remote_post( $url, $args );

    if ( $google_return['response']['code'] == 200 ) {
        return array( 1 );
    } else {
        return array( 0, $google_return )  ;
    }
}

function fts_gsheet_get_spreadsheets_list( $spreadsheet_provider ) {
    if( $spreadsheet_provider != 'gsheet' ) {
        return;
    }

    $fts_access_token = json_decode(get_option( 'fts_access_token'), true );
    $google_spreadsheets_return = wp_remote_get( "https://www.googleapis.com/drive/v3/files?q=mimeType%20%3D%20'application%2Fvnd.google-apps.spreadsheet'
		     &access_token=".$fts_access_token['access_token'] );

    if( $google_spreadsheets_return['response']['code'] != 200 ) {
        return array( false, $google_spreadsheets_return['response']['message'] );
    }

    $body                      = json_decode( $google_spreadsheets_return['body'] , true );
    $spreadsheet_list          = $body['files'] ;
    $spreadsheets_id_and_title = array();

    foreach( $spreadsheet_list  as $spreadsheet ) {
        $spreadsheets_id_and_title[$spreadsheet['id']] = $spreadsheet['name'];
    }

    return $spreadsheets_id_and_title;
}

function fts_gsheet_get_worksheets_list( $spreadsheet_provider, $spreadsheet_id ) {

    if( $spreadsheet_provider != 'gsheet' ) {
        return;
    }

    if( !$spreadsheet_id ) {
        return;
    }

    $fts_access_token = json_decode( get_option( 'fts_access_token' ), true );

    if ( empty( $fts_access_token ) ) {
        return false;
    }

    $google_return = wp_remote_get( 'https://sheets.googleapis.com/v4/spreadsheets/' . $spreadsheet_id . '/?access_token=' . $fts_access_token['access_token'] );
    $body          = json_decode( $google_return['body'], true );
    $sheets        = array();

    foreach ( $body['sheets'] as $value ) {
        $sheets[$value['properties']['sheetId']] = $value['properties']['title'] ;
    }

    if ( empty( $sheets ) ) {
        return false ;
    } else {
        return $sheets;
    }
}

function fts_gsheet_get_sheet_details( $spreadsheets_id='', $worksheet_name='', $token='' ) {

    if ( empty( $spreadsheets_id ) OR empty( $worksheet_name ) ) {
        return "spreadsheets_id or worksheet_name is empty";
    }

    if( !$token ) {
        $raw_token = json_decode( get_option( 'fts_access_token' ), true );
        $token     = $raw_token["access_token"];
    }

    $google_return = wp_remote_get( 'https://sheets.googleapis.com/v4/spreadsheets/'. $spreadsheets_id . '/values/'. $worksheet_name . '!A1:yZ1?access_token='. $token );
    $responce = $google_return['response']['code'];

    if ( $responce != 200 ) {
        return false;
    }

    $body = json_decode( $google_return['body'] , true );

    # Err handaling
    if ( !isset( $body['values'][0] ) ) {
        return $google_return;
    }

    $key_array = array();

    for( $x = "A"; ; $x++ ) {
        array_push( $key_array, $x );
        if( $x == "ZZ" ) break;
    }

    $count           = count( $body['values'][0] );
    $key_title_array = array_combine( array_slice( $key_array, 0, $count ), $body['values'][0] );

    return $key_title_array;
}

add_action( 'fts_update_relations', 'fts_gsheet_update_relations' );

function fts_gsheet_update_relations() {
    global $wpdb;

    $id                      = esc_sql( trim( $_POST['edit_id'] ) );
    $table                   = $wpdb->prefix . 'form_to_sheet';
    $spreadsheet_provider_id = $wpdb->get_var( "SELECT spreadsheet_provider from {$table} WHERE id = {$id}" );

    if( $spreadsheet_provider_id != 'gsheet' ) {
        return;
    }

    $title     = sanitize_text_field( $_POST['relation_title'] );
    $status    = sanitize_text_field( $_POST['status'] );
    $relations = $_POST['relations'];

    if ( $status == 'update_relation' ) {

        if ( $status != 'update_relation' &&  !empty( $id ) ) {
            exit;
        }

        $action_status = $wpdb->update( $table,
            array(
                'integration_title' => $title,
                'relations'         => json_encode( $relations, true ),
            ),
            array(
                'id' => $id
            )
        );
    }

    if ( $action_status ) {
        form_to_sheet_redirect( admin_url( 'admin.php?page=form-to-sheet&status=1' ) );
    } else {
        form_to_sheet_redirect( admin_url( 'admin.php?page=form-to-sheet&status=0' ) );
    }
}